/**
*	bios.c
*	oCIXx
*	Copyright Junnichi Tomaru
*/
#include	<machine.h>
#include	"iodefine.h"
#include	"define.h"
#include	"userdef.h"

extern word	count1ms;
extern char	keybuf[4];
extern char	keypnt;

/* ----- ^C} ----- */

/**
*	1msPʂ̎𓾂
*	 in	Ȃ
*	out	JE^l
*/
word	getcount1ms( void )
{
	word	ret;

	set_imask_ccr( DI );
	ret = count1ms;
	set_imask_ccr( EI );

	return	ret;
}


/**
*	1msPʂő҂
*	 in	ms
*	out	Ȃ
*/
void	waitms( word ms )
{
	word	wt;

	for( wt = getcount1ms( ); (( getcount1ms( ) - wt ) < ms ); )
	;
}


/* ----- SIO ----- */

/**
*	PM
*	 in	f[^
*	out	Ȃ
*/
void	setsio1( char data )
{
	while( SCI3.SSR.BIT.TDRE == 0 )
	;
	SCI3.TDR = data;
}


/**
*	P[hM
*	 in	f[^
*	out	Ȃ
*/
void	setsio1w( word data )
{
	ui_t	t;

	t.data = data;
	setsio1( t.bytes.hi );
	setsio1( t.bytes.lo );
}


/**
*	Q[hM
*	 in	f[^
*	out	Ȃ
*/
void	setsio1l( dword data )
{
	ul_t	t;

	t.data = data;
	setsio1( t.bytes.hh );
	setsio1( t.bytes.hl );
	setsio1( t.bytes.lh );
	setsio1( t.bytes.ll );
}


/**
*	񑗐M
*	 in	
*	out	Ȃ
*/
void	setsiostr( char *buf )
{
	while( *buf ){
		setsio1( *buf );
		buf++;
	}
}


/* end of sio.c */
