/**
*	lbg[NԊOR	C
*	 \Pbg0: HTTP
*	 \Pbg1: DHCP
*	Copyright Junnichi Tomaru
*/
#define	_GLOBAL_DEFINED
#include	"remoir.h"

const int	eepadr[] = { EEP_DATA1, EEP_DATA2, EEP_DATA3, EEP_DATA4, EEP_DATA5, EEP_DATA6, EEP_DATA7 };
byte	osts;

#ifdef __cplusplus
extern "C" {
void	abort( void );
}
#endif

#ifdef __cplusplus
void	abort( void )
{

}
#endif


/**
*	DHCPJEgJn
*	 in	Ȃ
*	out	Ȃ
*/
void	start_dhcpcnt( void )
{
	dhcp_flg = DHCP_CLEAR;
	dhcp_rfrh = off;
	RTC.RTCCR2.BIT.SEIE = 1;/* 1b荞 */
	RTC.RTCCR1.BIT.RUN = 1;	/* Jn */
}


/**
*	DHCPJEg~
*	 in	Ȃ
*	out	Ȃ
*/
void	stop_dhcpcnt( void )
{
	RTC.RTCCR2.BIT.SEIE = 0;/* 1b荞݋֎~ */
	RTC.RTCCR1.BIT.RUN = 0;	/* ~ */
}


/**
*	JE^EbZ[W\
*	 in	\
*	out	Ȃ
*/
void	dispcounter( char disp )
{
	char	buf[16];
	const char	*msg[] = { "EXPIRE", "REBIND", " RENEW" };

	if( disp < CNT_REM ){
		lcdprint( 10, 1, msg[disp] );
	}
	else{
		if( dhcp_t1 > 999999L ){
			lcdprint( 10, 1, "------" );
		}
		else{
			ultoaz( dhcp_t1, buf );
			lcdprint( 10, 1, buf + 4 );	/* JEg\ */
		}
	}
}


/**
*	[XԃJEgEĐ\E\
*	 in	Ȃ
*	out	Ȃ
*/
void	dhcp_sequense( SOCKET sn )
{
	char	flg;

	if( dhcpcnten == on ){	/* JEgL */
		if( dhcp_rfrh == on ){
			dhcp_rfrh = off;
			flg = dhcp_flg;
			if( flg == DHCP_CLEAR ){
				dispcounter( CNT_REM );
			}
			else if( flg & DHCP_EXPIRE ){
				dispcounter( CNT_EXPIRE );	/* \ */
				dhcpcnten = off;
				stop_dhcpcnt( );
				myipaddr = netmask = gateway = 0;
				dhcp_discover( sn );		/* Ȃ */
			}
			else if( flg & DHCP_REBIND ){
				dispcounter( CNT_REBIND );	/* REBINDoߕ\ */
				dhcp_request( sn, DHCP_REBINDING );	/* Đ\ */
			}
			else if( flg & DHCP_RENEW ){
				dispcounter( CNT_RENEW );	/* RENEWINGo */
				dhcp_request( sn, DHCP_RENEWING );	/* Đ\ */
			}
		}
	}
}


/**
*	EEPROMAhXlǂݏo
*	 in	addr: EEPAhX
*		 fix: ftHgl
*	out	AhXl
*/
dword	get_eepaddr( int addr, dword fix )
{
	dword_t	dw;

	dw.words.hi = geteeprom( addr );
	dw.words.lo = geteeprom( addr + 1 );
	if( dw.data == 0xffffffff ){
		dw.data = fix;
	}

	return	dw.data;
}


/**
*	DHCPZbgAbv
*	 in	Ȃ
*	out	Ȃ
*/
void	dhcp_setup( void )
{
	char	adr;

	dhcpcnten = off;
	dhcp_mode = ( ADDRFIX == 0 )? DHCP_ABORT: DHCP_INIT;
	if( dhcp_mode ){/* DHCP̂Ƃ́Am肷܂ł͖ */
		myipaddr = netmask = gateway = 0;
	}
	else{		/* Œlbg[Nݒgp */
		adr = DIPSW & 0x7;
		myipaddr = get_eepaddr( EEP_ADDR, IPADDR ) + adr;	/* IPAhXݒ */
		netmask = get_eepaddr( EEP_MASK, NETMASK );	/* lbg}XNݒ */
		gateway = get_eepaddr( EEP_GW, GATEWAY );	/* ftHgQ[gEFCݒ */
	}
}


/**
*	l̏
*	 in	Ȃ
*	out	Ȃ
*/
void	valinit( void )
{
	char	i;

	osts = 0xff;
	keypnt = 0;
	learn = learn_end = off;
	dhcp_rfrh = off;
	dhcp_flg = DHCP_CLEAR;
	for( i = 0; i < 4; i++ ){
		keybuf[i] = 0;
	}
	/* ----- EEPROM̕A ----- */
	read_macaddress( );	/* MACAhX */
	read_httpport( );	/* WWW|[g */
	read_irportname( );	/* |[g */
	read_irctrl( );		/* 䖼 */
	read_password( );	/* pX[h */

	dhcp_setup( );		/* IPAhX̓ǂݍ݂Ȃ */
}


/**
*	wK󋵕\
*	 in	Ȃ
*	out	Ȃ
*/
void	disp_learn( void )
{
	char	i, c, d;

	lcdlocate( 0, 1 );
	for( i = 0; i < 7; i++ ){
		c = 1 << i;
		d = ( irflg & c )? ( i + '1' ): ' ';
		lcdputch( d );
	}
}


/**
*	I[vjO
*	 in	Ȃ
*	out	Ȃ
*/
void	opening( void )
{
	char	i, buf[16];

	lcdinit( );
	lcdprint( 0, 0, "MAC:" );
	for( i = 0; i < 6; i++ ){
		lcdputstr( uctoahz( mac_address[i], buf ));
	}
	lcdprint( 0, 1, "VERSION:" );
	lcdputstr( VERSION );
	waitms( 2000U );
	lcdinit( );
	if( dhcp_mode ){
		lcdprint( 0, 0, "DHCP MODE" );
	}
	else{
		lcdprint( 0, 0, inet_ntoa( myipaddr, buf ));
		lcdprint( 10, 1, "FIXED." );
	}
	disp_learn( );
}


/**
*	p^[wK
*	wḰALAN̎MȂ
*	 in	0-6:
*	out	Ȃ
*/
void	learn_seq( char ch )
{
	byte	c, *p, flg, rtcf;
	ui_t	t;
	word	wt;
	int	adr;
	swbool	save;

	rtcf = RTC.RTCCR1.BIT.RUN;
	RTC.RTCCR1.BIT.RUN = 0;	/* ~ */
	TV.TCRV0.BYTE = 0x48;	/* ~ */

	memset((byte *)RAMTOP, 0xff, 256 );
	IRRCV_ENBL( );		/* dON */
	LEARN_ON( );
	COMPLETE_OFF( );
	learn = learn_end = off;
	ircnt = 0;
	irpnt = (byte *)RAMTOP;	/* obt@ʒu */
	save = on;
	oirinflg = 1;		/* l:Hi */
	IENR2.BIT.IENTB1 = 1;	/* 荞݋ */
	while( learn_end == off ){	/* wKI҂ */
		if( LEARN == 1 ){	/* wK */
			IENR2.BIT.IENTB1 = 0;	/* 荞݋֎~ */
			save = off;
			break;
		}
	}
	LEARN_OFF( );
	IRRCV_DSBL( );		/* dOFF */
	/* ----- EEPROMɊi[ ----- */
	if( save == on ){
		p = (byte *)RAMTOP;
		flg = 0;
		adr = eepadr[ch];	/* EEPROM擪 */
		while( flg == 0 ){
			c = *p;
			t.bytes.hi = c;
			p++;
			if( c == 0xff ){	/* f[^I[ */
				flg = 1;
			}
			c = *p;
			t.bytes.lo = c;
			p++;
			if( c == 0xff ){	/* f[^I[ */
				flg = 1;
			}
			seteeprom( adr, t.data );
			adr++;
		}
		irflg |= ( 1 << ch );	/* LtO */
		seteeprom( EEP_IRFLG, irflg );
		COMPLETE_ON( );
	}
	TV.TCRV0.BYTE = 0x4b;		/* f/128 ăX^[g */
	RTC.RTCCR1.BIT.RUN = rtcf;	/* ĊJ */
	wt = getcount1ms( );
	while(( getcount1ms( ) - wt ) < 1000U )	/* 1bEFCg */
	;
	COMPLETE_OFF( );
}


/**
*	C
*	 in	Ȃ
*	out	Ȃ
*/
void	main( void )
{
	dword	addr;
	word	port, wt;
	char	sr, ir, flg, pog, lflg;
	int	len, i, sts;

	valinit( );
	waitms( 10U );	/* W5100Zbg */
	/* ----- W5100 ----- */
	if( w5100_init( myipaddr, netmask, gateway ) == FALSE ){
		COMPLETE_ON( );
	}
	w5100_meminit( MEM_CH0_4K + MEM_CH1_4K, MEM_CH0_4K + MEM_CH1_4K );

	/* ----- HTTP SOCKET:0,PORT:80 ----- */
	http_socket = socket( SOCKET0, SOCK_STREAM, http_port, NOOPTION );
	if( http_socket != INVALID_SOCKET ){
		if( listen( http_socket ) == SOCKET_ERROR ){	/* LISTENɂ */
			close( http_socket );
			http_socket = INVALID_SOCKET;
		}
		else{
			LISTEN_ON( );
		}
	}
	/* ----- DHCP SOCKET:1,PORT:68 ----- */
	if( dhcp_mode == DHCP_INIT ){	/* DHCPL̂Ƃ */
		dhcp_socket = socket( SOCKET1, SOCK_DGRAM, BOOTPC_PORT, NOOPTION );
	}
	else{
		dhcp_socket = INVALID_SOCKET;
	}
	opening( );	/* \ */
	if( dhcp_socket != INVALID_SOCKET ){
		dhcp_discover( dhcp_socket );	/* DHCPpPbgM */
	}
	flg = lflg = 0;
	_forever{
		if(( LEARN == 0 ) && ( lflg == 1 )){	/* wKXCb` */
			pog = ( DIPSW >> 4 ) & 0x7;
			if( pog != 7 ){
				learn_seq( pog );
				disp_learn( );
			}
		}
		lflg = LEARN;	/* ŐV */
		if( http_socket != INVALID_SOCKET ){	/* HTTP\PbgL */
			ir = getsn_ir( http_socket );
			if( ir & Sn_IR_CON ){		/* \Pbg0ڑ */
				setsn_ir( http_socket, Sn_IR_CON );
				LISTEN_OFF( );
				ESTABLISH_ON( );
				flg = 1;
				wt = getcount1ms( );
			}
			else if( ir & Sn_IR_DISCON ){	/* ؒfvM */
				ESTABLISH_OFF( );
				setsn_ir( http_socket, Sn_IR_DISCON );
				close( http_socket );
				flg = 0;
				http_socket = socket( SOCKET0, SOCK_STREAM, http_port, 0 );
				if( http_socket != INVALID_SOCKET ){	/* ăI[v */
					if( listen( http_socket ) == SOCKET_ERROR ){
						close( http_socket );
						http_socket = INVALID_SOCKET;
					}
					else{
						LISTEN_ON( );
					}
				}
			}
			if( flg ){	/* ڑmĎ */
				if( ir & Sn_IR_RECV ){	/* \Pbg1M */
					setsn_ir( http_socket, Sn_IR_RECV );
					len = recv( http_socket, (byte *)RXBUF, RXBUFSIZE );
					if( len != SOCKET_ERROR ){	/*  */
						http_input( http_socket, (char *)RXBUF );
					}
				}
				if(( getcount1ms( ) - wt ) >= 10000U ){	/* ^CAEg */
					ESTABLISH_OFF( );
					wt = getcount1ms( );
					close( http_socket );
					http_socket = socket( SOCKET0, SOCK_STREAM, http_port, 0 );
					if( http_socket != INVALID_SOCKET ){	/* ăI[v */
						if( listen( http_socket ) == SOCKET_ERROR ){
							close( http_socket );
							http_socket = INVALID_SOCKET;
						}
						else{
							LISTEN_ON( );
						}
					}
				}
			}
		}
		if( dhcp_socket != INVALID_SOCKET ){	/* DHCP|[gL */
			if( getsn_ir( dhcp_socket ) & Sn_IR_RECV ){	/* M */
				setsn_ir( dhcp_socket, Sn_IR_RECV );
				len = recvfrom( dhcp_socket, (byte *)RXBUF, RXBUFSIZE, &addr, &port );
				if(( port == BOOTPS_PORT ) && ( len != SOCKET_ERROR )){
					dhcp_input( dhcp_socket );
				}
			}
		}
		dhcp_sequense( dhcp_socket );	/* DHCPĐ\Ȃ */
	}
}


/* end of remoir.c */
