/**
*	socket.h
*	\PbgQ	wb_
*	Copyright (c)Junnichi Tomaru
*/

#ifndef	_SOCKET_DEFINED_
#define	_SOCKET_DEFINED_

#include	<stddef.h>
#include	"w5100.h"
#include	"userdef.h"
#include	"ut.h"

#define	SOCKET		int	/* \Pbg^ϐ` */
#define	INVALID_SOCKET	(SOCKET)(~0)	/* G[ԍ */
#define	SOCKET_ERROR	INVALID_SOCKET

/* \Pbgԍ` */
#define	SOCKET0		0
#define	SOCKET1		1
#define	SOCKET2		2
#define	SOCKET3		3

/* \Pbg`(socket()ł̃vgRw) */
#define	SOCK_STREAM	Sn_MR_TCP
#define	SOCK_DGRAM	Sn_MR_UDP
#define	SOCK_RAW	Sn_MR_IPRAW
#define	SOCK_RDM	Sn_MR_MACRAW
#define	SOCK_PPPoE	Sn_MR_PPPOE

/* IvVtO(Sn_MR) */
#define	NOOPTION	0x00
#define	MULTICAST	0x80
#define	NO_DELAY_ACK	0x20
#define	USE_IGMP_V1	0x20

/* vgRԍ */
#define	IPPROTO_ICMP	1	/* ICMP */
#define	IPPROTO_TCP	6	/* TCP */
#define	IPPROTO_UDP	17	/* UDP */
#define	IPPROTO_RAW	255	/* IP RAW */

/* vg^Cv */
extern SOCKET	socket( SOCKET sn, byte protocol, word port_sn, byte opt );	/* \Pbg */
extern int	close( SOCKET sn );	/* \PbgN[Y */
extern int	listen( SOCKET sn );	/* ڑL[̍쐬 (T[o) */
extern int	connect( SOCKET sn, dword addr, word port );	/* T[oւ̐ڑ (NCAg) */
extern int	disconnect( SOCKET sn );	/* \Pbgؒf */

extern int	send( SOCKET sn, byte *buf, int len );
extern int	recv( SOCKET sn, byte *buf, int len );
extern int	sendto( SOCKET sn, byte *buf, int len, dword addr, word port );
extern int	recvfrom( SOCKET sn, byte *buf, int len, dword *addr, word *port );

#endif

/* end of socket.h */
