/**
*	hwsetup.c
*	n[hEFA
*	Copyright Junnichi Tomaru
*/
#include	"iodefine.h"

#ifdef __cplusplus
extern "C" {
#endif
extern void HardwareSetup( void );
#ifdef __cplusplus
}
#endif

/**
*	@\ݒ
*/
void	HardwareSetup( void )
{
	/* ȓd */
	MSTCR1.BYTE = 0x40;	/* IIC֎~ */

	/* s샂[h */
	IO.PMR1.BYTE = 0x2;	/* P22:TxD */
	IO.PMR3.BYTE = 0x0;	/* CMOSo */
	IO.PMR5.BYTE = 0x0;	/* CMOS,ėp|[g */

	/* |[g */
	IO.PDR1.BYTE = 0x00;
	IO.PDR2.BYTE = 0x04;
	IO.PDR3.BYTE = 0x00;
	IO.PDR6.BYTE = 0x00;
	IO.PDR7.BYTE = 0x74;
	IO.PDR8.BYTE = 0xe0;

	/* |[g 1:o 0: */
	IO.PCR1 = 0xe6;
	IO.PCR2 = 0x1d;		/*  */
	IO.PCR3 = 0xff;		/* LCDC */
	IO.PCR5 = 0x00;
	IO.PCR6 = 0x00;		/* f[^oX: */
	IO.PCR7 = 0x77;
	IO.PCR8 = 0xe0;		/* CS,RD,WR */

	/* ^C}B1 50us^C} */
	TB1.TMB1.BYTE = 0x85;	/* Auto-reload,f/16 */
	TB1.TLB1 = 205;		/* 16MHz / 16 / 50 = 20000Hz = 50us */

	/* ^C}V 1ms^C} ėpC^[o^C} */
	TV.TCNTV = 0;		/* NA */
	TV.TCORA = 124;		/* 16MHz / 128 / 125 = 1000Hz */
	TV.TCRV1.BYTE = 0x1;
	TV.TCRV0.BYTE = 0x4b;	/* CMIEA,AŃNA,f/128 */

	/* SIO3 fobOp */
	SCI3.SCR3.BYTE = 0x00;	/* TE,RE=0 */
	SCI3.SMR.BYTE = 0x00;	/* 8bit,S1,PN, */
	SCI3.BRR = 51;		/* 9600bps */
	SCI3.SCR3.BYTE = 0x20;	/* TE=1,RE=0 */

	/* RTC DHCPJEgp */
	RTC.RTCCR1.BIT.RUN = 0;	/* ~ */
	RTC.RTCCR1.BIT.RST = 1;	/* Zbg */
	RTC.RTCCR1.BIT.RST = 0;
	RTC.RTCCR2.BYTE = 0;
	RTC.RSECDR.BYTE = 0;	/* JE^Zbg */
	RTC.RMINDR.BYTE = 0;
	RTC.RHRDR.BYTE = 0;
	RTC.RWKDR.BYTE = 0;
	RTC.RTCCSR.BYTE = 0x08;	/* RTC */

	/* 荞݋ */
	IENR1.BIT.IENTA = 1;	/* RTC荞 */
}


/* end of hwsetup.c */
